import { z } from '@hono/zod-openapi';

export const ExpressCompanySchema = z.object({
  id: z.number().int().positive().openapi({ description: '快递公司ID' }),
  name: z.string().min(1, '物流公司名称不能为空').max(50, '物流公司名称最多50个字符').openapi({
    description: '物流公司名称',
    example: '顺丰速运'
  }),
  code: z.string().min(1, '物流编号不能为空').max(20, '物流编号最多20个字符').openapi({
    description: '物流编号',
    example: 'SF'
  }),
  state: z.number().int().min(1).max(2).default(1).openapi({
    description: '使用状态 1可用 2禁用',
    example: 1
  }),
  sort: z.number().int().nonnegative('排序值必须为非负数').nullable().openapi({
    description: '优先级 值越大越优先',
    example: 100
  }),
  createdAt: z.coerce.date().openapi({
    description: '创建时间',
    example: '2024-01-01T12:00:00Z'
  }),
  updatedAt: z.coerce.date().openapi({
    description: '更新时间',
    example: '2024-01-01T12:00:00Z'
  }),
  createdBy: z.number().int().positive().nullable().openapi({
    description: '创建用户ID',
    example: 1
  }),
  updatedBy: z.number().int().positive().nullable().openapi({
    description: '更新用户ID',
    example: 1
  })
});

export const CreateExpressCompanyDto = z.object({
  name: z.string().min(1, '物流公司名称不能为空').max(50, '物流公司名称最多50个字符').openapi({
    description: '物流公司名称',
    example: '顺丰速运'
  }),
  code: z.string().min(1, '物流编号不能为空').max(20, '物流编号最多20个字符').openapi({
    description: '物流编号',
    example: 'SF'
  }),
  state: z.number().int().min(1).max(2).default(1).openapi({
    description: '使用状态 1可用 2禁用',
    example: 1
  }),
  sort: z.number().int().nonnegative('排序值必须为非负数').nullable().optional().openapi({
    description: '优先级 值越大越优先',
    example: 100
  })
});

export const UpdateExpressCompanyDto = z.object({
  name: z.string().min(1, '物流公司名称不能为空').max(50, '物流公司名称最多50个字符').optional().openapi({
    description: '物流公司名称',
    example: '顺丰速运'
  }),
  code: z.string().min(1, '物流编号不能为空').max(20, '物流编号最多20个字符').optional().openapi({
    description: '物流编号',
    example: 'SF'
  }),
  state: z.number().int().min(1).max(2).optional().openapi({
    description: '使用状态 1可用 2禁用',
    example: 1
  }),
  sort: z.number().int().nonnegative('排序值必须为非负数').nullable().optional().openapi({
    description: '优先级 值越大越优先',
    example: 100
  })
});